from setuptools import setup, Extension, find_packages

from Cython.Build import cythonize

import subprocess

extensions = [
    Extension('io_uring.core', [
            'io_uring/lib/liburing/src/setup.c', 
            'io_uring/lib/liburing/src/queue.c', 
            'io_uring/lib/liburing/src/register.c',
            'io_uring/core.pyx',
        ], 
        include_dirs=[
            'io_uring/lib/liburing/src/include/', 
            'io_uring/',
            '.'
        ],
    ),
    Extension('io_uring.loop', [
            'io_uring/loop.pyx'
        ], 
        include_dirs=[
            'io_uring/lib/liburing/src/include/', 
            'io_uring/',
            '.'
        ],
    ),
]
# maybe there is a way to add this to setup()
subprocess.run(['bash', 'io_uring/lib/liburing/configure'])

setup(
    name="io_uring", 
    description="Cython wrapper for liburing and asyncio event loop",
    ext_modules=cythonize(extensions, build_dir="io_uring/c", language_level=3),
    packages=find_packages(),
    package_dir={'io_uring': 'io_uring'},
    zip_safe=False,
    long_description=open('README.md').read(),
    package_data={'io_uring': [
        'lib/liburing/src/**/*.[ch]',
        'lib/liburing/*.*',
    ]},
    version="0.2.0",
)

